"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lint = void 0;
const tslib_1 = require("tslib");
const file_resolver_1 = require("@markuplint/file-resolver");
const ml_engine_1 = (0, tslib_1.__importDefault)(require("./ml-engine"));
async function lint(targetList, options) {
    const res = [];
    const files = await (0, file_resolver_1.resolveFiles)(targetList);
    for (const file of files) {
        const engine = new ml_engine_1.default(file, options);
        const result = await engine.exec();
        if (!result) {
            continue;
        }
        res.push(result);
    }
    return res;
}
exports.lint = lint;
