import meow from 'meow';
export declare const help = "\nUsage\n\t$ markuplint <HTML file pathes (glob format)>\n\t$ <stdout> | markuplint\n\nOptions\n\t--config-file,  -c FILE_PATH  Ruleset file path.\n\t--fix,                        Fix HTML.\n\t--format,       -f FORMAT     Output format. Support \"JSON\", \"Simple\" and \"Standard\". Default: \"Standard\".\n\t--no-color,                   Output no color.\n\t--problem-only, -p            Output only problems, without passeds.\n\t--verbose                     Output with detailed information.\n\n\t--init                        Initialize settings interactively.\n\t--create-rule                 Add the scaffold of a custom rule.\n\n\t--help,         -h            Show help.\n\t--version,      -v            Show version.\n\nExamples\n\t$ markuplint verifyee.html --ruleset path/to/.markuplintrc\n\t$ cat verifyee.html | markuplint\n";
export declare const cli: meow.Result<{
    init: {
        type: "boolean";
        default: false;
    };
    createRule: {
        type: "boolean";
        default: false;
    };
    configFile: {
        type: "string";
        alias: string;
    };
    fix: {
        type: "boolean";
        default: false;
    };
    format: {
        type: "string";
        alias: string;
    };
    color: {
        type: "boolean";
        default: true;
    };
    problemOnly: {
        type: "boolean";
        alias: string;
        default: false;
    };
    verbose: {
        type: "boolean";
        default: false;
    };
}>;
export declare type CLIOptions = typeof cli.flags;
