"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.messageToString = exports.invisibleSpace = exports.space = exports.w = exports.p = exports.markuplint = void 0;
const tslib_1 = require("tslib");
const cli_color_1 = (0, tslib_1.__importDefault)(require("cli-color"));
// @ts-ignore
const eastasianwidth_1 = (0, tslib_1.__importDefault)(require("eastasianwidth"));
exports.markuplint = `markup${cli_color_1.default.xterm(39)('lint')}`;
const eaw = eastasianwidth_1.default;
function p(s, pad, start = false) {
    const l = w(`${s}`.trim());
    const d = pad - l;
    const _ = ' '.repeat(d < 0 ? 0 : d);
    return start ? `${_}${s}` : `${s}${_}`;
}
exports.p = p;
function w(s) {
    return s.replace(/./g, _ => '0'.repeat(eaw.characterLength(_))).length;
}
exports.w = w;
function space(str) {
    return str
        .replace(/\s+/g, $0 => {
        return cli_color_1.default.xterm(8)($0);
    })
        .replace(/ /g, $0 => '•')
        .replace(/\t/g, $0 => '→   ');
}
exports.space = space;
function invisibleSpace(str) {
    return str.replace(/\t/g, $0 => '    ').replace(/./g, $0 => ' ');
}
exports.invisibleSpace = invisibleSpace;
function messageToString(message, reason) {
    if (!reason) {
        return message;
    }
    return `${message} / ${reason}`;
}
exports.messageToString = messageToString;
